﻿Public Class Form1
    ' Paste text, rich text, and HTML.
    Private Sub btnPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPaste.Click
        PasteAvailableData()
    End Sub

    ' If the user pressed Ctrl+V, paste.
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If (e.Control AndAlso e.KeyCode = Keys.V) Then
            PasteAvailableData()
            e.Handled = True
        End If
    End Sub

    ' Paste whichever text formats are available.
    Private Sub PasteAvailableData()
        ' Plain text.
        If (Clipboard.ContainsText(TextDataFormat.Text)) Then
            txtPlain.Text = Clipboard.GetText(TextDataFormat.Text)
        Else
            txtPlain.Clear()
        End If

        ' Rich text.
        If (Clipboard.ContainsText(TextDataFormat.Rtf)) Then
            txtRich.Rtf = Clipboard.GetText(TextDataFormat.Rtf)
        Else
            txtRich.Clear()
        End If

        ' HTML.
        If (Clipboard.ContainsText(TextDataFormat.Html)) Then
            txtHtml.Text = Clipboard.GetText(TextDataFormat.Html)
        Else
            txtHtml.Clear()
        End If
    End Sub
End Class
